#include "ikk-factory-test.h"
#include "ikk-debug.h"
#include "ikk-token.h"
#include "tl_common.h"
#include "../driver/ikk-button.h"
#define AGING_TEST_15MIN_VALUE			0xA1
#define AGING_TEST_8HOU_VALUE			0xA2
#define AGINE_TEST_DONE_VALUE			0xFA
//Ѿϻ־
#define FACTORY_TEST_VALUE				0xF1
//ʼֵ
#define TEST_INIT_VALUE					0xFF

static ev_timer_event_t *kFactoryTestEvt = NULL;
s32 kFactoryTestEventHandler(void *arg);


typedef struct{
	uint8_t u8BtnId;
	uint8_t u8BtnLongPressTimes; //touch keys must be long pressed 2 times, mechanical keys is pressed 1 time
	uint32_t u32AgingForceExitTimeMs;  //key long pressed time for  exit aging test
	uint32_t u32AgingForceExitTimeCounter;  //key long pressed time for  exit aging test
	BtnActionEnum elastBtnAction;
	BtnActionEnum eCurrentBtnAction;
	bool bIsFirstBtnLongPressed ;
	uint32_t u32FirstBtnLongPressedCountDown;
}FactoryTestControllerSt;

FactoryTestControllerSt g_stFactoryTestControllerList[AGING_EXIT_MAX_BTN_NUM] \
	= {{BTN_UNKNOW_ID, 0, 0, 0, EBA_IDLE, EBA_IDLE, 0, 0}, {BTN_UNKNOW_ID, 0, 0, 0, EBA_IDLE, EBA_IDLE, 0, 0}};

static FactoryTestStatusEnum g_eFactoryTestStatus = FTS_NORMAL;
static FactoryTestStatusEnum g_eLastFactoryTestStatus = FTS_NORMAL;
static uint32_t g_u32AgingTotalTimeMS = 0;
static pFactoryTestPollCallback g_pFactoryTestPollCallback = NULL;
static 	uint8_t g_u8LongPressedKeyIndex = 0;
static uint32_t g_u32Count = 0;
/*	DESP: get the test index by id.
 * 	Auth: mazj.20200227.
 * */
static uint8_t kGetFactoryTestIndexByID(uint8_t id )
{
	for(int index = 0; index < AGING_EXIT_MAX_BTN_NUM; ++index ) {
		if( g_stFactoryTestControllerList[index].u8BtnId != BTN_UNKNOW_ID ) {
			if( g_stFactoryTestControllerList[index].u8BtnId == id ) {
				return index;
			}
		}else break;
	}

	return 0XFF;
}

FactoryTestStatusEnum kGetFactoryTestStatus(void)
{
	return g_eFactoryTestStatus;
}


void  kFactoryTestBtnActionCallback(unsigned char button_id, BtnActionEnum action)
{
	uint8_t u8FactoryTestIndex = kGetFactoryTestIndexByID(button_id);
	iKonkeAfSelfPrint("######kFactoryTestBtnActionCallback,index(%d) id (%d)action(%d)\r\n",u8FactoryTestIndex,button_id, action);
	if (u8FactoryTestIndex != 0xFF){
		if(action == EBA_LONGPRESS)
			g_stFactoryTestControllerList[u8FactoryTestIndex].eCurrentBtnAction = EBA_PRESSED;
		else
			g_stFactoryTestControllerList[u8FactoryTestIndex].eCurrentBtnAction = action;

		//ָλ,ʱ䰴ҲԶ
		if (g_eFactoryTestStatus == FTS_AGING_WAITING && g_stFactoryTestControllerList[g_u8LongPressedKeyIndex].eCurrentBtnAction == EBA_RELEASED){
			g_eFactoryTestStatus = FTS_AGING_FORCE_REBOOT;
			g_u32Count = FACTORY_TEST_POLL_TIMES; //ִԶ庯
			iKonkeAfSelfPrint("######33333333333333333 FactoryTest Released\r\n");
		}
	}

}

void kFactoryTestInit(pFactoryTestPollCallback callback, FactoryTestConfSt conf_list[], uint8_t btn_num)
{
#if FACTORY_TEST_ENABLE
	if(NULL == callback || NULL == conf_list || btn_num > AGING_EXIT_MAX_BTN_NUM) {
		return;
	}
	for (uint8_t i = 0; i < btn_num; i++){
		g_stFactoryTestControllerList[i].u8BtnId = conf_list[i].u8BtnId;
		g_stFactoryTestControllerList[i].u8BtnLongPressTimes = conf_list[i].u8BtnLongPressTimes;
		g_stFactoryTestControllerList[i].u32AgingForceExitTimeMs = conf_list[i].u32AgingForceExitTimeMs;
	}


	iKonkeAfSelfPrint("######g_stFactoryTestControllerList[0].u8BtnId= %d u8BtnLongPressTimes = %d\r\n", g_stFactoryTestControllerList[0].u8BtnId,  g_stFactoryTestControllerList[0].u8BtnLongPressTimes);
	iKonkeAfSelfPrint("######g_stFactoryTestControllerList[1].u8BtnId= %d u8BtnLongPressTimes = %d\r\n", g_stFactoryTestControllerList[1].u8BtnId,  g_stFactoryTestControllerList[1].u8BtnLongPressTimes);

	if (kGetAgingTestValue() != AGINE_TEST_DONE_VALUE){
		kSetAgingTestValue(AGING_TEST_15MIN_VALUE);
		g_eFactoryTestStatus = FTS_START;
		//ϻ¼
		if(kFactoryTestEvt){
			TL_ZB_TIMER_CANCEL(&kFactoryTestEvt);
		}
		kFactoryTestEvt = TL_ZB_TIMER_SCHEDULE(kFactoryTestEventHandler, NULL, 1000);
		g_eFactoryTestStatus = FTS_START;
	}else {
		g_eFactoryTestStatus = FTS_NORMAL;
	}
	kBtnaIRQCallbackRegister(kFactoryTestBtnActionCallback);
	g_pFactoryTestPollCallback = callback;
	g_u32AgingTotalTimeMS = 0;
//	g_u8AgingForceExitBtnId = btn_id;
#else
	uint8_t value = TEST_INIT_VALUE;
	kSetAgingTestValue(value);
	g_eFactoryTestStatus = FTS_NORMAL;
#endif
}


s32 kFactoryTestEventHandler(void *arg)
{
	iKonkeAfSelfPrint("######kFactoryTestEventHandler status(%d)\r\n", g_eFactoryTestStatus);

	g_u32AgingTotalTimeMS += FACTORY_TEST_POLL_TTME_1S;

	if (g_eFactoryTestStatus != FTS_AGING_WAITING && g_eFactoryTestStatus != FTS_AGING_WAITING_SECOND_PRESS){
		switch (g_eFactoryTestStatus)
		{
			case (FTS_START):
				//g_eFactoryTestStatus = FTS_AGING_15MIN;
				g_u32Count = FACTORY_TEST_POLL_TIMES;
				break;
			case (FTS_AGING_15MIN):
				//ϵ15ʱ䵽15ڿԶ̰ͳ
				if (g_u32AgingTotalTimeMS >= FACTORY_TEST_15MIN_MS){
					kSetAgingTestValue(AGING_TEST_8HOU_VALUE);
					g_eFactoryTestStatus = FTS_AGING_8HOU_START;
					//15Ӻ¿ʼʱ
					g_u32AgingTotalTimeMS = 0;
					g_u32Count = FACTORY_TEST_POLL_TIMES;//㴦Զ庯
				}
				break;
			case (FTS_AGING_8HOU_START):
					//еLED״̬һ£ڻصʵ
					g_eFactoryTestStatus = FTS_AGING_8HOU;
				break;
			case (FTS_AGING_8HOU):
				//ϵ12Сʱϻʱ䵽12СʱڲԶ̰ͳ
				if (g_u32AgingTotalTimeMS >= FACTORY_TEST_8HOU_MS){
					kSetAgingTestValue(AGINE_TEST_DONE_VALUE);
					g_eFactoryTestStatus = FTS_AGING_DONE;
				}
				break;
			case (FTS_AGING_DONE):
				//ϻ˳ǰ¼
				//return;
				g_u32Count = FACTORY_TEST_POLL_TIMES;//㴦Զ庯
				break;
			case (FTS_AGING_FORCE_EXIT):
				g_eFactoryTestStatus = FTS_AGING_WAITING;
				break;
			case (FTS_AGING_WAITING):
				break;
			case (FTS_AGING_FIRST_LONG_PRESSED):
				g_eFactoryTestStatus = 	FTS_AGING_WAITING_SECOND_PRESS;
				break;
			case (FTS_AGING_WAITING_SECOND_PRESS):
				break;
			default:
				break;
		}
	}

	for (uint8_t index = 0; index < AGING_EXIT_MAX_BTN_NUM; index++){
		if (g_stFactoryTestControllerList[index].u8BtnId != BTN_UNKNOW_ID ){
			if (g_stFactoryTestControllerList[index].eCurrentBtnAction == EBA_PRESSED \
					&& g_stFactoryTestControllerList[index].elastBtnAction != EBA_PRESSED){

				g_stFactoryTestControllerList[index].elastBtnAction = EBA_PRESSED;
				//g_stFactoryTestControllerList[index].eCurrentBtnAction = EBA_PRESSING;
				//óʱ
				g_stFactoryTestControllerList[index].u32AgingForceExitTimeCounter = \
						g_stFactoryTestControllerList[index].u32AgingForceExitTimeMs / FACTORY_TEST_POLL_TTME_1S;
			}else if (g_stFactoryTestControllerList[index].eCurrentBtnAction == EBA_RELEASED \
					&& g_stFactoryTestControllerList[index].elastBtnAction != EBA_RELEASED){
				iKonkeAfSelfPrint("&&&&&&& EBA_RELEASED u32AgingForceExitTimeCounter == %d\r\n",\
						g_stFactoryTestControllerList[index].u32AgingForceExitTimeCounter);
				g_stFactoryTestControllerList[index].elastBtnAction = EBA_RELEASED;
				g_stFactoryTestControllerList[index].u32AgingForceExitTimeCounter = 0;
			}else {
				 g_stFactoryTestControllerList[index].elastBtnAction  = g_stFactoryTestControllerList[index].eCurrentBtnAction;
			}
			//ʱ20S5S
			if (g_stFactoryTestControllerList[index].u32AgingForceExitTimeCounter > 0 \
					&& g_stFactoryTestControllerList[index].eCurrentBtnAction == EBA_PRESSED){

				iKonkeAfSelfPrint("######u32AgingForceExitTimeCounter-- %d\r\n", \
						g_stFactoryTestControllerList[index].u32AgingForceExitTimeCounter);

				if (--g_stFactoryTestControllerList[index].u32AgingForceExitTimeCounter == 0){

					iKonkeAfSelfPrint("######u32AgingForceExitTimeCounter == 0\r\n");

					if ( g_stFactoryTestControllerList[index].u8BtnLongPressTimes == LONG_PRESS_1_TIMES \
							|| g_stFactoryTestControllerList[index].bIsFirstBtnLongPressed == true){
						//successfully exit aging test
						g_eFactoryTestStatus = FTS_AGING_FORCE_EXIT;
						kSetAgingTestValue(AGINE_TEST_DONE_VALUE);
						g_u32Count = FACTORY_TEST_POLL_TIMES; //ִԶ庯
						//ֹϻ״̬
						g_stFactoryTestControllerList[index].u32FirstBtnLongPressedCountDown = 0;
						g_u8LongPressedKeyIndex = index;
						//g_u32AgingTotalTimeMS = FACTORY_TEST_12HOU_MS;
						iKonkeAfSelfPrint("######11111111111 == 0\r\n");
					}else if ( g_stFactoryTestControllerList[index].u8BtnLongPressTimes == LONG_PRESS_2_TIMES){
						//Ҫβ˳ϻ
						g_stFactoryTestControllerList[index].bIsFirstBtnLongPressed = true;
						g_stFactoryTestControllerList[index].u32FirstBtnLongPressedCountDown = \
								(FIRST_BTN_LONG_PRESSED_VALIED_TIME_MS + FACTORY_TEST_POLL_TTME_1S)/ FACTORY_TEST_POLL_TTME_1S;
						g_u32Count = FACTORY_TEST_POLL_TIMES;//㴦Զ庯
						//¼ǰϻ״̬
						g_eLastFactoryTestStatus = g_eFactoryTestStatus;
						g_eFactoryTestStatus = FTS_AGING_FIRST_LONG_PRESSED;

						iKonkeAfSelfPrint("######2222222222222222222222 == 0\r\n");
					}
				}
			}else {
				//g_stFactoryTestControllerList[index].elastBtnAction = g_stFactoryTestControllerList[index].eCurrentBtnAction;
			}

			//ڶγЧʱ䵹ʱ
			if (g_stFactoryTestControllerList[index].u32FirstBtnLongPressedCountDown > 0 && g_stFactoryTestControllerList[index].u8BtnLongPressTimes == LONG_PRESS_2_TIMES){
				if (--g_stFactoryTestControllerList[index].u32FirstBtnLongPressedCountDown == 0){
					g_stFactoryTestControllerList[index].bIsFirstBtnLongPressed = false;
					//ָ֮ǰϻ״̬
					g_eFactoryTestStatus = g_eLastFactoryTestStatus;
				}
			}
		}
	}

	//10SִһԶϻ,ʱݲͬ״̬¼ʱ䣬øִ
	if (g_u32Count++ >= FACTORY_TEST_POLL_TIMES){
		g_u32Count = 0;
		//ûԶϻԷ
		if (g_pFactoryTestPollCallback){
			g_pFactoryTestPollCallback(g_eFactoryTestStatus);
		}

		if (g_eFactoryTestStatus == FTS_START){
			g_eFactoryTestStatus = FTS_AGING_15MIN;
		}else if (g_eFactoryTestStatus == FTS_AGING_DONE){
			//ϻ˳ǰ¼
			return 0;
		}
	}
	return 0;
}



